function isInPrivateBrowsingMode() {
	var pbs;
	try { pbs = Components.classes["@mozilla.org/privatebrowsing;1"].getService(Components.interfaces.nsIPrivateBrowsingService); } catch (e) {}
	var privatebrowsingwarning = pbs && pbs.privateBrowsingEnabled && gIeTab.getBoolPref("coral.ietab.privatebrowsingwarning", true);
	if ( privatebrowsingwarning ) {
		var cookieService = Components.classes["@mozilla.org/cookieService;1"].getService(Components.interfaces.nsICookieService);
		var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var cookieManager = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieManager);
		try {
			var pbwFlag = cookieService.getCookieString(ioService.newURI("http://coralietab/", null, null), null);
			if (pbwFlag) {
				privatebrowsingwarning = pbwFlag.indexOf("privatebrowsingwarning=no") < 0;
				cookieManager.remove("coralietab", "privatebrowsingwarning", "/", false);
			}
		}
		catch (e) { }
	}
	
	return privatebrowsingwarning;
}

function shouldShowRetryPrompt() {
	if (gIeTab.getStrPref('coral.ietab.mode', "")=="advanced") {
		var m = /\?url=(\d+),(\S+)$/.exec(document.location.href);
		if (m) {
			var flags = parseInt(m[1]);
			var url = decodeURI(m[2]);
			if ( (flags == 0x4003) && gIeTab.startsWith(url, "http") && gIeTab.getBoolPref('coral.ietab.showprompt', true)) {
				return true;
			}
		}
	}
	return false;
}

function overlayCommandListener(event) {
	var msg;
	try { msg = JSON.parse(event.data); } catch (e) {}
	if (msg) {
		var ietab = document.getElementById("IETab");
		switch (msg.cmd) {
			case "goBack":
				ietab.goBack();
				break;
			case "goForward":
				ietab.goForward();
				break;
			case "cut":
				ietab.cut();
				break;
			case "copy":
				ietab.copy();
				break;
			case "paste":
				ietab.paste();
				break;
			case "selectAll":
				ietab.selectAll();
				break;
			case "refresh":
				ietab.refresh();
				break;
			case "stop":
				ietab.stop();
				break;
			case "saveAs":
				ietab.saveAs();
				break;
			case "print":
				ietab.print();
				break;
			case "printPreview":
				ietab.printPreview();
				break;
			case "printSetup":
				ietab.printSetup();
				break;
			case "find":
				ietab.find();
				break;
			case "viewSource":
				ietab.viewSource();
				break;
			case "focus":
				ietab.focus();
				break;
			case "displaySecurityInfo":    
				ietab.displaySecurityInfo();
				break;
			case "zoom":
				ietab.zoom(msg.zoomLevel);
				break;
			default:
				break;
		}
	}
}

/** This listener is only to repeat messages to XUL chrome */
function IETabNotifyListener(event) {
	var evt = document.createEvent("MessageEvent");
	evt.initMessageEvent("ContainerMessage", true, true, event.data, document.location.href, 0, window);
	document.dispatchEvent(evt);
}

function registerEventHandler() {
	window.addEventListener("OverlayCommand", overlayCommandListener, false);
	window.addEventListener("IETabNotify", IETabNotifyListener, false);
}